var alarmList = [
            "AL005 - Maximum temperature reached... switch off power",
            "AL025 - Extruder drive fault",
            "AL024 - Emergency off",
            "AL023 - Calender drive fault",
            "AL005 - Maximum temperature reached... switch off power",
            "AL022 - Calender drive fault"
        ];

var alarmListIterator = 0;
var scrollListIterator = 0;

var pageButtonsOn = [ page.getWidget("page1ButtonOn"),
                      page.getWidget("page2ButtonOn"),
                      page.getWidget("page3ButtonOn")];

var alarmMsgLabels = [ page.getWidget("alMsg3"), // reverse order
                       page.getWidget("alMsg2"),
                       page.getWidget("alMsg1"),
        ];

var alarmOnMaskWgt = page.getWidget("alarmOnMask");
var alarmOffMaskWgt = page.getWidget("alarmOffMask");

var state = new State;

function refreshAlarmList()
{
    for(var i=0; i<alarmMsgLabels.length; i++) {
        alarmMsgLabels[i].setProperty('text', alarmList[(alarmListIterator+i+scrollListIterator)%alarmList.length]);
    }
}

// Prints a new alarm message and set the alarm mask
function incrementAlarm()
{
    alarmListIterator = (alarmListIterator + 1)%alarmList.length;
    for(var i=0; i<alarmMsgLabels.length; i++) {
        alarmMsgLabels[i].setProperty('text', alarmList[(alarmListIterator+i)%alarmList.length]);
    }
    project.setTag('alarmTriggered', 1);
}

function scrollUpAlarms()
{
    scrollListIterator = (scrollListIterator + alarmList.length - 1)%alarmList.length;
    refreshAlarmList();
}

function scrollDownAlarms()
{
    scrollListIterator = (scrollListIterator + 1)%alarmList.length;
    refreshAlarmList();
}


function onAlarmTriggeredUpdate(me, eventInfo)
{
    if (eventInfo.newValue == true) {
        alarmOnMaskWgt.visible = 1;
        alarmOffMaskWgt.visible = 0;
    }

    return false;
}
     
function setupPage(me, eventInfo) 
{
    // show/hide current page icons
    for(var i=0; i<pageButtonsOn.length; i++) {
        if (i == (parseInt(eventInfo.newValue)-1)) {
            pageButtonsOn[i].visible = true;
            pageButtonsOn[i].y = 74;            
            pageButtonsOn[i].x = 0;            
        } else {            
            pageButtonsOn[i].visible = false;            
        }
    }
    return false; 
}


function onControl(me, eventInfo) 
{
    if (1 == parseInt(page.getWidget("ackButton").value)) {
        // reset alarm;
        project.setTag('alarmTriggered', 0);
        alarmOnMaskWgt.visible = 0;
        alarmOffMaskWgt.visible = 1;
        // force button release
        project.setTag('ctrlRequestAlarm', 0);
    }

    return false; 
}


// setup alarm messages
refreshAlarmList();
